"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCNode subclass:#PPCPluggableNode
	instanceVariableNames:'block'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCPluggableNode methodsFor:'accessing'!

block
	
	^ block
!

block: anObject
	
	block := anObject
! !

!PPCPluggableNode methodsFor:'as yet unclassified'!

acceptsEpsilon
	^ true
!

acceptsEpsilonOpenSet: set
	^ true
!

asInlined
    "Sadly, on Smalltalk/X blocks cannot be inlined because
     the VM does not provide enough information to map
     it back to source code. Very bad indeed!!"

    ((Smalltalk respondsTo:#isSmalltalkX) and:[ Smalltalk isSmalltalkX ]) ifTrue:[
		^ super asInlined
    ] ifFalse:[
		^ PPCInlinePluggableNode new
			name: name;
			block: block;
			yourself
    ]

!

compileWith: compiler effect: effect id: id
	| blockId |
	blockId := compiler idFor: block prefixed: #block.
	
	compiler startMethod: id.
	compiler addConstant: block as: blockId.
	compiler add: '^ ', blockId, ' value: context.'.
 ^ compiler stopMethod.
!

firstCharSet
	^ PPCharSetPredicate on: [:char | (block asParser parse: char asString) isPetitFailure not ]
!

prefix
	^ #plug
! !

!PPCPluggableNode methodsFor:'comparing'!

= anotherNode
	super = anotherNode ifFalse: [ ^ false ].
	^ block = anotherNode block.
!

hash
	^ super hash bitXor: block hash
! !

